%define _hardened_build 1

Summary:          A Name Service Switch (NSS, nsswitch) module 
Name:             nss-pam-ldapd
Version:          0.9.12
Release:          5%{?dist}
License:          LGPLv2+
URL:              http://arthurdejong.org/nss-pam-ldapd/
Source0:          http://arthurdejong.org/nss-pam-ldapd/nss-pam-ldapd-%{version}.tar.gz
Source1:          nslcd.tmpfiles
Source2:          nslcd.service

# Patch3000 is from fedora
Patch3000:        0002-Watch-for-uint32_t-overflows.patch

BuildRequires:    gcc make autoconf, automake
BuildRequires:    openldap-devel krb5-devel pam-devel
BuildRequires:    systemd-units
Requires(pre):    shadow
Requires(post):   systemd 
Requires(preun):  systemd 
Requires(postun): systemd 
Provides:         nss-ldapd = %{version}-%{release}
Obsoletes:        nss-ldapd < %{version}-%{release}
Conflicts:        nss_ldap
Conflicts:        pam_ldap

%description
Nss-pam-ldapd provides a Name Service Switch (NSS, nsswitch) module that 
allows your LDAP server to provide user account, group, host name, alias, 
netgroup, and basically any other information that you would normally get 
from /etc flat files or NIS. It also provides a Pluggable Authentication 
Module (PAM) to do identity and authentication management with an LDAP server
on unix systems.


%prep
%autosetup -p1


%build
autoreconf -ivf
%configure --libdir=/%{_lib} \
           --disable-utils \
           --with-pam-seclib-dir=/%{_lib}/security \
           --with-nslcd-pidfile=/run/nslcd/nslcd.pid \
           --with-nslcd-socket=/run/nslcd/socket
%make_build


%install
%make_install
install -D -m 0644 %{SOURCE1} %{buildroot}%{_tmpfilesdir}/%{name}.conf
install -D -m 0644 %{SOURCE2} %{buildroot}%{_unitdir}/nslcd.service
mkdir   -p -m 0755 %{buildroot}/run/nslcd
ln -s libnss_ldap.so.2 %{buildroot}/%{_lib}/libnss_ldap.so


%check
%make_build check


%pre
# creating group and user nslcd
getent group nslcd >/dev/null || groupadd -r nslcd
getent passwd nslcd >/dev/null || \
useradd -r -g nslcd -d / -s /sbin/nologin \
  -c "nslcd ldap user" nslcd 2> /dev/null || :


%post
/sbin/ldconfig
%systemd_post nslcd.service


%preun
%systemd_preun nslcd.service


%postun
/sbin/ldconfig
%systemd_postun nslcd.service


%files
%license COPYING
%doc AUTHORS ChangeLog NEWS README
%{_mandir}/man{5,8}/*
%defattr(-,root,root)
%attr(0775,nslcd,root) /run/nslcd
%config(noreplace) %attr(0640,root,root) %{_sysconfdir}/nslcd.conf
%config(noreplace) %attr(0644,root,root) %{_tmpfilesdir}/%{name}.conf
%{_unitdir}/nslcd.service
/%{_lib}/libnss_ldap.so*
/%{_lib}/security/pam_ldap.so
%{_sbindir}/{,rc}nslcd


%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.9.12-5
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.9.12-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.9.12-3
- Rebuilt for OpenCloudOS Stream 23

* Thu Feb 23 2023 doriscchao <doriscchao@tencent.com> - 0.9.12-2
- Moving temporary files from /var/run to /run

* Thu Jul 28 2022 doriscchao <doriscchao@tencent.com> - 0.9.12-1
- initial build, Version 0.9.12, Release 1
